package com.ibm.edp.cic.core.ant;

import java.util.List;

import org.apache.tools.ant.BuildException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.osgi.framework.Version;

import com.ibm.cic.ant.jar.OfferingId;
import com.ibm.cic.common.core.model.IIdentity;
import com.ibm.cic.common.core.repository.IRepository;
import com.ibm.edp.cic.core.helper.CicHelper;
import com.ibm.edp.cic.core.helper.Util;

public abstract class AbstarctCicOfferingBuilder extends AbstractCicTaskWrapper 
{		
    protected void doExecute() throws BuildException {

        if ( getDestMetadataDir() == null)
            log("destMetadataDir:null");//$NON-NLS-1$
        else
            log("destMetadataDir:" + getDestMetadataDir().toString());//$NON-NLS-1$
        
        dumpSrcRepositories();
        dumpIds("Offerings", getOfferings() );//$NON-NLS-1$
        
        createRepositoryGroup("CicOfferingBuilder"); //$NON-NLS-1$
        
        try {
            openSourceRepositories();
            
            OfferingId offering = getFirstOffering();
            
            if(offering != null)
            {
				IIdentity offeringId = CicHelper.getIdentity( offering.getId() );
				Version offeringVersion = offering.getVersion();			
	
				IRepository targetRepo = Util.obtainRepository( getDestMetadataDir().getAbsolutePath() );
				
				List result = create(offeringId, offeringVersion, getRepositoryGroup(), targetRepo, new NullProgressMonitor() );
				print( result );
            }
            else
            {
                log( "offeringId element was not specified" );//$NON-NLS-1$            	
            }
			
		} catch (Exception e) {
			throw new BuildException( e );
		}          
        finally {
            resetRepositoryGroup();
        }
    }
    
    protected abstract List create(IIdentity offeringId, Version offeringVersion, IRepository srcRepo, IRepository targetRepo, IProgressMonitor monitor) throws Exception;    
}
