package com.ibm.edp.cic.core.helper;


import java.io.File;
//import java.net.MalformedURLException;
//import java.net.URL;

//import com.ibm.cic.common.core.definitions.CommonDef;
//import com.ibm.cic.common.core.repository.DirectoryRepository;
import com.ibm.cic.common.core.repository.IRepository;
import com.ibm.cic.common.core.repository.IRepositoryGroup;
import com.ibm.cic.common.core.repository.IRepositoryInfo;
//import com.ibm.cic.common.core.repository.RemoteRepository;
import com.ibm.cic.common.core.repository.StandardRepository;

public final class Util 
{

//	private static final String PROTOCOL_FILE = CommonDef.Protocols.File;
//    /private static final String PROTOCOL_HTTP = CommonDef.Protocols.Http;
//    private static final String PROTOCOL_FTP = CommonDef.Protocols.Ftp;
	
    public static IRepository createRepository(String destination) 
    {
        IRepository repository = null;
        if (destination != null && destination.length() > 0) 
        {
        	setDirectory( destination );
        	repository = obtainRepository( destination );
        }
        return repository;
    }		

    public static IRepository obtainRepository(String destination) 
    {
        IRepository repository = null;
        if (destination != null && destination.length() > 0) 
        {
        	File fileDest = new File(destination);
        	fileDest.mkdirs();
        	
        	repository = StandardRepository.obtainStandalone( fileDest );
        }
        return repository;
    }		
    
/*    
	public static IRepository openRepository(IRepositoryGroup repositoryService, String serverLocation) {
		// or use it
		try {
			URL url = new URL(serverLocation);
			String protocol = url.getProtocol();
			if (PROTOCOL_HTTP.equals(protocol) || PROTOCOL_FTP.equals(protocol)) {
                String repInfo=
                 IRepositoryInfo.NAME       +IRepositoryInfo.VALUE_SEPARATOR +serverLocation                        +IRepositoryInfo.PROPERTY_SEPARATOR
                +IRepositoryInfo.TYPE       +IRepositoryInfo.VALUE_SEPARATOR +RemoteRepository.REPOSITORY_TYPE      +IRepositoryInfo.PROPERTY_SEPARATOR
                +IRepositoryInfo.VERSION    +IRepositoryInfo.VALUE_SEPARATOR +RemoteRepository.REPOSITORY_VERSION   +IRepositoryInfo.PROPERTY_SEPARATOR
                +IRepositoryInfo.LOCATION   +IRepositoryInfo.VALUE_SEPARATOR +serverLocation;
				
                return repositoryService.addExistingRepository(repInfo, true);
			} else if (PROTOCOL_FILE.equals(protocol)) {
                String repInfo=
                    IRepositoryInfo.NAME       +IRepositoryInfo.VALUE_SEPARATOR +serverLocation                           +IRepositoryInfo.PROPERTY_SEPARATOR
                   +IRepositoryInfo.TYPE       +IRepositoryInfo.VALUE_SEPARATOR +DirectoryRepository.REPOSITORY_TYPE      +IRepositoryInfo.PROPERTY_SEPARATOR
                   +IRepositoryInfo.VERSION    +IRepositoryInfo.VALUE_SEPARATOR +DirectoryRepository.REPOSITORY_VERSION   +IRepositoryInfo.PROPERTY_SEPARATOR
                   +IRepositoryInfo.LOCATION   +IRepositoryInfo.VALUE_SEPARATOR +url.getFile();
				return repositoryService.addExistingRepository(repInfo, true);
			}
		} catch (MalformedURLException e) {
			// e.printStackTrace();
			// try to create a dir-based repo
			// serverLocation is a pointer to a direcotry.
			// we can try and create it here or add "file:" to the dir
			// before creating the URL
            String repInfo=
                IRepositoryInfo.NAME       +IRepositoryInfo.VALUE_SEPARATOR +serverLocation                           +IRepositoryInfo.PROPERTY_SEPARATOR
               +IRepositoryInfo.TYPE       +IRepositoryInfo.VALUE_SEPARATOR +DirectoryRepository.REPOSITORY_TYPE      +IRepositoryInfo.PROPERTY_SEPARATOR
               +IRepositoryInfo.VERSION    +IRepositoryInfo.VALUE_SEPARATOR +DirectoryRepository.REPOSITORY_VERSION   +IRepositoryInfo.PROPERTY_SEPARATOR
               +IRepositoryInfo.LOCATION   +IRepositoryInfo.VALUE_SEPARATOR +serverLocation;
            return repositoryService.addExistingRepository(repInfo, true);
            
		} catch (Exception e) {
			e.printStackTrace();
		}
        return null;	
	}    
*/	
	
	public static IRepository openRepository(IRepositoryGroup repositoryService, String serverLocation) {
		try 
		{
			String repInfo = 
			IRepositoryInfo.NAME + IRepositoryInfo.VALUE_SEPARATOR + serverLocation +
			IRepositoryInfo.PROPERTY_SEPARATOR + 
			IRepositoryInfo.LOCATION + IRepositoryInfo.VALUE_SEPARATOR + serverLocation;
			
			return repositoryService.addExistingRepository(repInfo, true);
		} 
		catch (Exception e) 
		{
			e.printStackTrace();
		}
		return null;
	} 	

    public static void setDirectory(String a_dir)
	{
		File path2= new File(a_dir);
		terminateFile( path2 );
		path2.mkdirs();
	}	

	public static void terminateFile( File file )
	{
	   if( !file.exists() ) return;
		   
	   if( file.isDirectory() )
	   {
	      File [] contents = file.listFiles();
	      for(int i=0; i < contents.length; i++)
	      {
			terminateFile( contents[i] );
	      }
	   }
	   file.delete();
	}		
}
