package com.ibm.edp.cic.core.templates.ant;

import java.net.URL;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.osgi.framework.Bundle;

import com.ibm.edp.cic.core.EdpCicCorePlugin;
import com.ibm.edp.cic.core.templates.AbstractTemplateProcessor;
import com.ibm.edp.cic.core.templates.ITemplateContext;

public class AntTemplateProcessor extends AbstractTemplateProcessor
{

	public void processTemplates() throws CoreException 
	{
		// TODO Auto-generated method stub
		Bundle bundle = Platform.getBundle( EdpCicCorePlugin.getFragmentId() );
		
		ITemplateContext ctx = getTemplateContext();
		String templateUri = ctx.getProperty( ITemplateContext.TEMPLATE_URI );
		//System.err.println( "COX " + templateUri );
		//System.err.println( "COX " + bundle.getState() );
		
		
		try
		{
			URL buildTemplate = bundle.getEntry( templateUri );
			
			//System.err.println( "KL " + FileLocator.resolve(buildTemplate) );
			
			AntExecutor antExecutor = new AntExecutor();
			antExecutor.executeEclipse( FileLocator.resolve(buildTemplate), ctx.getMap() );
			
			
		}catch(Throwable t)
		{
			//t.printStackTrace();
			IStatus status = new Status(IStatus.ERROR, EdpCicCorePlugin.getPluginId(), IStatus.CANCEL, "AntTemplateProcessor:: " + t.getMessage(), t) ;
			throw new CoreException( status );						
		}
	}
}
