package com.ibm.edp.cic.core.templates.ant.task;

import java.io.File;
import java.io.FileInputStream;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import java.util.Map;
import java.util.Properties;

import com.ibm.edp.cic.core.templates.ITemplateContext;
import com.ibm.edp.cic.core.templates.ITemplateProcessor;
import com.ibm.edp.cic.core.templates.PropertyTemplateContext;
import com.ibm.edp.cic.core.templates.ant.AntTemplateProcessor;

public class GenerateWasExtension extends Task
{
    private File cipdir = null;
    private File destrepositorydir = null;
    private File propertyfile = null;
   
    public void execute() throws BuildException
    {
    	log("zz1");
        Map map = null;
        if( propertyfile != null && !propertyfile.exists() )
        {
           throw new BuildException( "Specified property file does not exist. " + propertyfile.getAbsolutePath() ); 	
        } 
        else if( propertyfile != null && propertyfile.exists() )
        {
    	   try
    	   {			  
    		  Properties p = new Properties();
    		  FileInputStream fis = new FileInputStream( propertyfile );
    		  p.load( fis );
    		  fis.close();
    		  map = p;
    		  
    	   }catch(Throwable t)
    	   {
    		   throw new BuildException( "Cannot load specified property file. " + propertyfile.getAbsolutePath() );    
    	   }                          	
        }
        
        if( map == null )
        {
        	map = getProject().getProperties();	        	
        }
        	
		ITemplateContext ctx = new PropertyTemplateContext();
		ctx.setMap( map );		
		ctx.setProperty( ITemplateContext.TEMPLATE_URI, "templates/was.test.env.extension.xml" );
		
		ctx.setProperty( "package.cip.location",  cipdir.getAbsolutePath() );
		ctx.setProperty( "package.output.location",  destrepositorydir.getAbsolutePath() );		
			
		ITemplateProcessor tp = new AntTemplateProcessor();		
		tp.setTemplateContext( ctx );
		
		try 
		{
			tp.processTemplates();
		} catch (Exception e) {			
			//e.printStackTrace();
			throw new BuildException( e.getMessage(), e );
		}
             	    	
    }

	public void setCipdir(String cipdir) {
		if(cipdir != null) this.cipdir = new File( cipdir );
	}

	public void setPropertyfile(String propertyfile) {
		if(propertyfile != null) this.propertyfile = new File( propertyfile );
	}

	public void setDestrepositorydir(String destrepositorydir) {
		if(destrepositorydir != null) this.destrepositorydir = new File( destrepositorydir );
	}
   
}
